#!/usr/bin/python
# -*- coding: UTF-8 -*-

from optparse import OptionParser, OptionGroup
import sys

from pyeole.bacula import test_bacula_support, mount_bacula_support, umount_bacula_support

def main():
    #get options
    parser = OptionParser(usage="Seulement une option \n%prog [option]")
    parser.add_option("--mount", action="store_true", dest="mount",
            default=False, help=u"Monte le support")
    parser.add_option("--umount", action="store_true", dest="umount",
            default=False, help=u"Démonte le support")
    parser.add_option("-t", "--test", action="store_true", dest="test",
            default=False, help=u"Test de la configuration du support")

    (options, args) = parser.parse_args()


    if options.test == False and options.mount == False and options.umount == False:
        parser.print_help()
        sys.exit(1)

    if options.test != False:
        try:
            ret = test_bacula_support()
            if ret == True:
                print "Test OK"
            else:
                print ret
        except Exception, e:
            print e
            sys.exit(1)

    if options.mount != False:
        try:
            ret = mount_bacula_support()
            if ret == True:
                print "Montage OK"
            else:
                print ret
        except Exception, e:
            print e
            sys.exit(1)

    if options.umount != False:
        try:
            ret = umount_bacula_support()
            if ret == True:
                print "Démontage OK"
            else:
                print ret
        except Exception, e:
            print e
            sys.exit(1)

if __name__ == "__main__":
    main()

