#!/usr/bin/env python
"""
Lanceur

"""

import sys
from optparse import OptionParser
#from operator import itemgetter, attrgetter
import restore

from pyeole.bacula import _save_bacula_conf, instance_bacula
from pyeole.bacularestore import exit_if_running_jobs
# ____________________________________________________________

class Option(object):
    """
    Objet de creation de l'import
    """

    def __init__(self, name, doc, jobid):
        self.name = name
        self.doc = doc
        self.jobid = jobid

    def add_optparse_option(self, parser):
        """
        bind entre le parser et la fonction
        """
        parser.add_option("--"+self.name, help=self.doc,
                        action='callback',
                        callback=self.callback,
                        callback_args=(self.jobid,))

# ____________________________________________________________

def utils_imp(module, plug_options):
    """Utilitaire d'import du module plugin"""
    return __import__(module, globals(), locals(), plug_options)

def filter_built(module):
    """Retourne la liste des modules publics"""
    return filter(lambda x: not(x.__contains__('__')), dir(module))

def add_options(option_names):
    """Ajout des fonctions a partir des plugins"""
    descr = []
    #on recharge le module plugin pour pouvoir importer les modules necessaires
    plugin_imp = utils_imp('restore', option_names)
    option = Option('all', 'Toutes les options', 0)
    setattr(option, 'callback', opt_all)
    descr.append(option)
    option = Option('config', 'Genere le fichier de configuration', 0)
    setattr(option, 'callback', opt_config)
    descr.append(option)
    list_bacula = list_bacula_restore()
    for name in option_names:
        func = sys.modules['restore.'+name]
        jobid = list_bacula.index(name)+1
        option = Option(name, func.__doc__, jobid)
        setattr(option, 'callback', func.execute)
        descr.append(option)
    return descr

def opt_all(option, opt_str, value, parser, fake_jobid):
    """Excution des fonction pour toutes les options"""
    exit_if_running_jobs()
    plug_options = filter_built(restore)
    plugins = utils_imp('restore', plug_options)
    plug_options_ordered = []
    list_bacula = list_bacula_restore()
    #gestion des priorites lors de l'appel du module
    for plug in plug_options:
        func = sys.modules['restore.'+plug]
        jobid = list_bacula.index(plug)+1
        if not dir(func).__contains__('priority'):
            print "need priority for {0}".format(str(func))
        #exclude script with priority 0
        if func.priority != 0:
            plug_options_ordered.append((func.priority, func.execute, jobid))

    plug_options_ordered = sorted(plug_options_ordered)
    for plug in plug_options_ordered:
        plug[1](option, opt_str, value, parser, plug[2], False)
        print ""


def list_bacula_restore():
    plug_options = filter_built(restore)
    plug_options.sort()
    return plug_options

def opt_config(option, opt_str, value, parser, fake_jobid):
    plug_options = list_bacula_restore()
    #script_file = '/usr/share/eole/bacula/bacularestore.py'
    tmpl_file = '/var/lib/creole/bacula-restore.conf'
    config_file = '/etc/bacula/bacula-restore.conf'
    dico_file = '/var/lib/eole/config/bacula-restore.conf'
    #config_fh = open(config_file, 'w')
    bacula_restore_name = []
    for plug in plug_options:
        bacula_restore_name.append(plug)
    dico = {'bacula_restore_name': bacula_restore_name}
    _save_bacula_conf(dico_file, dico)
    instance_bacula(tmpl_file, config_file, dico_file)

#        tmpl = """Job {{
#  Name = "Restore{0}"
#  JobDefs = "Restore-defs"
#  # Debut Sauvegarde
#  RunBeforeJob = "{1} --{2} pre"
#  # Fin Sauvegarde
#  RunAfterJob = "{1} --{2} post"
#  # Sauvegarde echouee !
#  RunAfterFailedJob = "{1} --{2} err"
#}}
#
#""".format(plug.capitalize(), script_file, plug)
        #config_fh.write(tmpl)
    #config_fh.close()

def main():
    """Fonction principal"""
    parser = OptionParser()
    plug_options = filter_built(restore)
    descr = add_options(plug_options)
    #config = Config(descr)
    for opt in descr:
        opt.add_optparse_option(parser)
    parser.parse_args()
    if len(sys.argv) == 1:
        parser.print_help()
        sys.exit(1)

if __name__ == '__main__':
    main()
